// author:	Szabolcs Czuczor (BME-IIT)

#include "Ogre.h"
#include "OgreEffectWrapper.h"
#include "ManagedOgreRenderTexturePass.h"
#include "PMFNormalMapPass.h"

/**
 *	@brief: Construtor.
 */
PMFNormalMapPass::PMFNormalMapPass(
			Root* mRoot,unsigned int width,unsigned int height,
		 	TextureType texType, PixelFormat internalFormat,
			const NameValuePairList *miscParams,
			bool fullScreenQuadRenderer,String renderTextureName)
:ManagedOgreRenderTexturePass(mRoot,renderTextureName,width,height,texType,internalFormat,miscParams,fullScreenQuadRenderer)
{
	this->setMaterialName("PMF/NormalMap");
}

/**
 *	@brief: Destructor.
 */
PMFNormalMapPass::~PMFNormalMapPass() {
}


void PMFNormalMapPass::onRenderStart(NameValuePairList* namedParams){
	effectWrapper->SetTechniqueToUse(0);
	effectWrapper->BeginPass();
}

void PMFNormalMapPass::onRenderEnd(NameValuePairList* namedParams){
	effectWrapper->EndPass();
}

